/* Easing.c generated by valac 0.56.3, the Vala compiler
 * generated from Easing.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
/**
 * Utility functions to calculate progress of transitions.
 * Initially ported from clutter's clutter-enums.h and clutter-easing.c
 */

#include "plank.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef gdouble (*PlankEasingFunc) (gdouble t, gdouble d);

#define PLANK_TYPE_ANIMATION_MODE_MAPPING (plank_animation_mode_mapping_get_type ())
typedef struct _PlankAnimationModeMapping PlankAnimationModeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankAnimationModeMapping {
	PlankAnimationMode mode;
	PlankEasingFunc func;
	gchar* name;
};

 G_GNUC_INTERNAL GType plank_animation_mode_mapping_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
 G_GNUC_INTERNAL PlankAnimationModeMapping* plank_animation_mode_mapping_dup (const PlankAnimationModeMapping* self);
 G_GNUC_INTERNAL void plank_animation_mode_mapping_free (PlankAnimationModeMapping* self);
 G_GNUC_INTERNAL void plank_animation_mode_mapping_copy (const PlankAnimationModeMapping* self,
                                        PlankAnimationModeMapping* dest);
 G_GNUC_INTERNAL void plank_animation_mode_mapping_destroy (PlankAnimationModeMapping* self);
 G_GNUC_INTERNAL gdouble plank_linear (gdouble t,
                      gdouble d);
static gdouble _plank_linear_plank_easing_func (gdouble t,
                                         gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_quad (gdouble t,
                            gdouble d);
static gdouble _plank_ease_in_quad_plank_easing_func (gdouble t,
                                               gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_quad (gdouble t,
                             gdouble d);
static gdouble _plank_ease_out_quad_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_quad (gdouble t,
                                gdouble d);
static gdouble _plank_ease_in_out_quad_plank_easing_func (gdouble t,
                                                   gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_cubic (gdouble t,
                             gdouble d);
static gdouble _plank_ease_in_cubic_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_cubic (gdouble t,
                              gdouble d);
static gdouble _plank_ease_out_cubic_plank_easing_func (gdouble t,
                                                 gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_cubic (gdouble t,
                                 gdouble d);
static gdouble _plank_ease_in_out_cubic_plank_easing_func (gdouble t,
                                                    gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_quart (gdouble t,
                             gdouble d);
static gdouble _plank_ease_in_quart_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_quart (gdouble t,
                              gdouble d);
static gdouble _plank_ease_out_quart_plank_easing_func (gdouble t,
                                                 gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_quart (gdouble t,
                                 gdouble d);
static gdouble _plank_ease_in_out_quart_plank_easing_func (gdouble t,
                                                    gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_quint (gdouble t,
                             gdouble d);
static gdouble _plank_ease_in_quint_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_quint (gdouble t,
                              gdouble d);
static gdouble _plank_ease_out_quint_plank_easing_func (gdouble t,
                                                 gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_quint (gdouble t,
                                 gdouble d);
static gdouble _plank_ease_in_out_quint_plank_easing_func (gdouble t,
                                                    gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_sine (gdouble t,
                            gdouble d);
static gdouble _plank_ease_in_sine_plank_easing_func (gdouble t,
                                               gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_sine (gdouble t,
                             gdouble d);
static gdouble _plank_ease_out_sine_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_sine (gdouble t,
                                gdouble d);
static gdouble _plank_ease_in_out_sine_plank_easing_func (gdouble t,
                                                   gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_expo (gdouble t,
                            gdouble d);
static gdouble _plank_ease_in_expo_plank_easing_func (gdouble t,
                                               gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_expo (gdouble t,
                             gdouble d);
static gdouble _plank_ease_out_expo_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_expo (gdouble t,
                                gdouble d);
static gdouble _plank_ease_in_out_expo_plank_easing_func (gdouble t,
                                                   gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_circ (gdouble t,
                            gdouble d);
static gdouble _plank_ease_in_circ_plank_easing_func (gdouble t,
                                               gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_circ (gdouble t,
                             gdouble d);
static gdouble _plank_ease_out_circ_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_circ (gdouble t,
                                gdouble d);
static gdouble _plank_ease_in_out_circ_plank_easing_func (gdouble t,
                                                   gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_elastic (gdouble t,
                               gdouble d);
static gdouble _plank_ease_in_elastic_plank_easing_func (gdouble t,
                                                  gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_elastic (gdouble t,
                                gdouble d);
static gdouble _plank_ease_out_elastic_plank_easing_func (gdouble t,
                                                   gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_elastic (gdouble t,
                                   gdouble d);
static gdouble _plank_ease_in_out_elastic_plank_easing_func (gdouble t,
                                                      gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_back (gdouble t,
                            gdouble d);
static gdouble _plank_ease_in_back_plank_easing_func (gdouble t,
                                               gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_back (gdouble t,
                             gdouble d);
static gdouble _plank_ease_out_back_plank_easing_func (gdouble t,
                                                gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_back (gdouble t,
                                gdouble d);
static gdouble _plank_ease_in_out_back_plank_easing_func (gdouble t,
                                                   gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_bounce (gdouble t,
                              gdouble d);
static gdouble _plank_ease_in_bounce_plank_easing_func (gdouble t,
                                                 gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_out_bounce (gdouble t,
                               gdouble d);
static gdouble _plank_ease_out_bounce_plank_easing_func (gdouble t,
                                                  gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_out_bounce (gdouble t,
                                  gdouble d);
static gdouble _plank_ease_in_out_bounce_plank_easing_func (gdouble t,
                                                     gdouble d);
 G_GNUC_INTERNAL PlankEasingFunc plank_easing_func_for_mode (PlankAnimationMode mode);
 G_GNUC_INTERNAL const gchar* plank_easing_name_for_mode (PlankAnimationMode mode);
 G_GNUC_INTERNAL gdouble plank_ease_out_bounce_internal (gdouble t,
                                        gdouble d);
 G_GNUC_INTERNAL gdouble plank_ease_in_bounce_internal (gdouble t,
                                       gdouble d);

const PlankAnimationModeMapping PLANK_ANIMATION_MODES[33] = {{PLANK_ANIMATION_MODE_CUSTOM, NULL, "custom"}, {PLANK_ANIMATION_MODE_LINEAR, _plank_linear_plank_easing_func, "linear"}, {PLANK_ANIMATION_MODE_EASE_IN_QUAD, _plank_ease_in_quad_plank_easing_func, "easeInQuad"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUAD, _plank_ease_out_quad_plank_easing_func, "easeOutQuad"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD, _plank_ease_in_out_quad_plank_easing_func, "easeInOutQuad"}, {PLANK_ANIMATION_MODE_EASE_IN_CUBIC, _plank_ease_in_cubic_plank_easing_func, "easeInCubic"}, {PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, _plank_ease_out_cubic_plank_easing_func, "easeOutCubic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC, _plank_ease_in_out_cubic_plank_easing_func, "easeInOutCubic"}, {PLANK_ANIMATION_MODE_EASE_IN_QUART, _plank_ease_in_quart_plank_easing_func, "easeInQuart"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUART, _plank_ease_out_quart_plank_easing_func, "easeOutQuart"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART, _plank_ease_in_out_quart_plank_easing_func, "easeInOutQuart"}, {PLANK_ANIMATION_MODE_EASE_IN_QUINT, _plank_ease_in_quint_plank_easing_func, "easeInQuint"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUINT, _plank_ease_out_quint_plank_easing_func, "easeOutQuint"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT, _plank_ease_in_out_quint_plank_easing_func, "easeInOutQuint"}, {PLANK_ANIMATION_MODE_EASE_IN_SINE, _plank_ease_in_sine_plank_easing_func, "easeInSine"}, {PLANK_ANIMATION_MODE_EASE_OUT_SINE, _plank_ease_out_sine_plank_easing_func, "easeOutSine"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE, _plank_ease_in_out_sine_plank_easing_func, "easeInOutSine"}, {PLANK_ANIMATION_MODE_EASE_IN_EXPO, _plank_ease_in_expo_plank_easing_func, "easeInExpo"}, {PLANK_ANIMATION_MODE_EASE_OUT_EXPO, _plank_ease_out_expo_plank_easing_func, "easeOutExpo"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO, _plank_ease_in_out_expo_plank_easing_func, "easeInOutExpo"}, {PLANK_ANIMATION_MODE_EASE_IN_CIRC, _plank_ease_in_circ_plank_easing_func, "easeInCirc"}, {PLANK_ANIMATION_MODE_EASE_OUT_CIRC, _plank_ease_out_circ_plank_easing_func, "easeOutCirc"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC, _plank_ease_in_out_circ_plank_easing_func, "easeInOutCirc"}, {PLANK_ANIMATION_MODE_EASE_IN_ELASTIC, _plank_ease_in_elastic_plank_easing_func, "easeInElastic"}, {PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC, _plank_ease_out_elastic_plank_easing_func, "easeOutElastic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, _plank_ease_in_out_elastic_plank_easing_func, "easeInOutElastic"}, {PLANK_ANIMATION_MODE_EASE_IN_BACK, _plank_ease_in_back_plank_easing_func, "easeInBack"}, {PLANK_ANIMATION_MODE_EASE_OUT_BACK, _plank_ease_out_back_plank_easing_func, "easeOutBack"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK, _plank_ease_in_out_back_plank_easing_func, "easeInOutBack"}, {PLANK_ANIMATION_MODE_EASE_IN_BOUNCE, _plank_ease_in_bounce_plank_easing_func, "easeInBounce"}, {PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE, _plank_ease_out_bounce_plank_easing_func, "easeOutBounce"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, _plank_ease_in_out_bounce_plank_easing_func, "easeInOutBounce"}, {PLANK_ANIMATION_MODE_LAST, NULL, "sentinel"}};

/**
 * The available animation modes
 */
static GType
plank_animation_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{PLANK_ANIMATION_MODE_CUSTOM, "PLANK_ANIMATION_MODE_CUSTOM", "custom"}, {PLANK_ANIMATION_MODE_LINEAR, "PLANK_ANIMATION_MODE_LINEAR", "linear"}, {PLANK_ANIMATION_MODE_EASE_IN_QUAD, "PLANK_ANIMATION_MODE_EASE_IN_QUAD", "ease-in-quad"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUAD, "PLANK_ANIMATION_MODE_EASE_OUT_QUAD", "ease-out-quad"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD, "PLANK_ANIMATION_MODE_EASE_IN_OUT_QUAD", "ease-in-out-quad"}, {PLANK_ANIMATION_MODE_EASE_IN_CUBIC, "PLANK_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, "PLANK_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC, "PLANK_ANIMATION_MODE_EASE_IN_OUT_CUBIC", "ease-in-out-cubic"}, {PLANK_ANIMATION_MODE_EASE_IN_QUART, "PLANK_ANIMATION_MODE_EASE_IN_QUART", "ease-in-quart"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUART, "PLANK_ANIMATION_MODE_EASE_OUT_QUART", "ease-out-quart"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART, "PLANK_ANIMATION_MODE_EASE_IN_OUT_QUART", "ease-in-out-quart"}, {PLANK_ANIMATION_MODE_EASE_IN_QUINT, "PLANK_ANIMATION_MODE_EASE_IN_QUINT", "ease-in-quint"}, {PLANK_ANIMATION_MODE_EASE_OUT_QUINT, "PLANK_ANIMATION_MODE_EASE_OUT_QUINT", "ease-out-quint"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT, "PLANK_ANIMATION_MODE_EASE_IN_OUT_QUINT", "ease-in-out-quint"}, {PLANK_ANIMATION_MODE_EASE_IN_SINE, "PLANK_ANIMATION_MODE_EASE_IN_SINE", "ease-in-sine"}, {PLANK_ANIMATION_MODE_EASE_OUT_SINE, "PLANK_ANIMATION_MODE_EASE_OUT_SINE", "ease-out-sine"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE, "PLANK_ANIMATION_MODE_EASE_IN_OUT_SINE", "ease-in-out-sine"}, {PLANK_ANIMATION_MODE_EASE_IN_EXPO, "PLANK_ANIMATION_MODE_EASE_IN_EXPO", "ease-in-expo"}, {PLANK_ANIMATION_MODE_EASE_OUT_EXPO, "PLANK_ANIMATION_MODE_EASE_OUT_EXPO", "ease-out-expo"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO, "PLANK_ANIMATION_MODE_EASE_IN_OUT_EXPO", "ease-in-out-expo"}, {PLANK_ANIMATION_MODE_EASE_IN_CIRC, "PLANK_ANIMATION_MODE_EASE_IN_CIRC", "ease-in-circ"}, {PLANK_ANIMATION_MODE_EASE_OUT_CIRC, "PLANK_ANIMATION_MODE_EASE_OUT_CIRC", "ease-out-circ"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC, "PLANK_ANIMATION_MODE_EASE_IN_OUT_CIRC", "ease-in-out-circ"}, {PLANK_ANIMATION_MODE_EASE_IN_ELASTIC, "PLANK_ANIMATION_MODE_EASE_IN_ELASTIC", "ease-in-elastic"}, {PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC, "PLANK_ANIMATION_MODE_EASE_OUT_ELASTIC", "ease-out-elastic"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, "PLANK_ANIMATION_MODE_EASE_IN_OUT_ELASTIC", "ease-in-out-elastic"}, {PLANK_ANIMATION_MODE_EASE_IN_BACK, "PLANK_ANIMATION_MODE_EASE_IN_BACK", "ease-in-back"}, {PLANK_ANIMATION_MODE_EASE_OUT_BACK, "PLANK_ANIMATION_MODE_EASE_OUT_BACK", "ease-out-back"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK, "PLANK_ANIMATION_MODE_EASE_IN_OUT_BACK", "ease-in-out-back"}, {PLANK_ANIMATION_MODE_EASE_IN_BOUNCE, "PLANK_ANIMATION_MODE_EASE_IN_BOUNCE", "ease-in-bounce"}, {PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE, "PLANK_ANIMATION_MODE_EASE_OUT_BOUNCE", "ease-out-bounce"}, {PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, "PLANK_ANIMATION_MODE_EASE_IN_OUT_BOUNCE", "ease-in-out-bounce"}, {PLANK_ANIMATION_MODE_LAST, "PLANK_ANIMATION_MODE_LAST", "last"}, {0, NULL, NULL}};
	GType plank_animation_mode_type_id;
	plank_animation_mode_type_id = g_enum_register_static ("PlankAnimationMode", values);
	return plank_animation_mode_type_id;
}

GType
plank_animation_mode_get_type (void)
{
	static volatile gsize plank_animation_mode_type_id__once = 0;
	if (g_once_init_enter (&plank_animation_mode_type_id__once)) {
		GType plank_animation_mode_type_id;
		plank_animation_mode_type_id = plank_animation_mode_get_type_once ();
		g_once_init_leave (&plank_animation_mode_type_id__once, plank_animation_mode_type_id);
	}
	return plank_animation_mode_type_id__once;
}

 G_GNUC_INTERNAL void
plank_animation_mode_mapping_copy (const PlankAnimationModeMapping* self,
                                   PlankAnimationModeMapping* dest)
{
	PlankEasingFunc _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 183 "../lib/Drawing/Easing.vala"
	(*dest).mode = (*self).mode;
#line 183 "../lib/Drawing/Easing.vala"
	_tmp0_ = (*self).func;
#line 183 "../lib/Drawing/Easing.vala"
	(*dest).func = _tmp0_;
#line 183 "../lib/Drawing/Easing.vala"
	_tmp1_ = (*self).name;
#line 183 "../lib/Drawing/Easing.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 183 "../lib/Drawing/Easing.vala"
	_g_free0 ((*dest).name);
#line 183 "../lib/Drawing/Easing.vala"
	(*dest).name = _tmp2_;
#line 236 "Easing.c"
}

 G_GNUC_INTERNAL void
plank_animation_mode_mapping_destroy (PlankAnimationModeMapping* self)
{
#line 187 "../lib/Drawing/Easing.vala"
	_g_free0 ((*self).name);
#line 244 "Easing.c"
}

PlankAnimationModeMapping*
plank_animation_mode_mapping_dup (const PlankAnimationModeMapping* self)
{
	PlankAnimationModeMapping* dup;
#line 183 "../lib/Drawing/Easing.vala"
	dup = g_new0 (PlankAnimationModeMapping, 1);
#line 183 "../lib/Drawing/Easing.vala"
	plank_animation_mode_mapping_copy (self, dup);
#line 183 "../lib/Drawing/Easing.vala"
	return dup;
#line 257 "Easing.c"
}

 G_GNUC_INTERNAL void
plank_animation_mode_mapping_free (PlankAnimationModeMapping* self)
{
#line 183 "../lib/Drawing/Easing.vala"
	plank_animation_mode_mapping_destroy (self);
#line 183 "../lib/Drawing/Easing.vala"
	g_free (self);
#line 267 "Easing.c"
}

static GType
plank_animation_mode_mapping_get_type_once (void)
{
	GType plank_animation_mode_mapping_type_id;
	plank_animation_mode_mapping_type_id = g_boxed_type_register_static ("PlankAnimationModeMapping", (GBoxedCopyFunc) plank_animation_mode_mapping_dup, (GBoxedFreeFunc) plank_animation_mode_mapping_free);
	return plank_animation_mode_mapping_type_id;
}

 G_GNUC_INTERNAL GType
plank_animation_mode_mapping_get_type (void)
{
	static volatile gsize plank_animation_mode_mapping_type_id__once = 0;
	if (g_once_init_enter (&plank_animation_mode_mapping_type_id__once)) {
		GType plank_animation_mode_mapping_type_id;
		plank_animation_mode_mapping_type_id = plank_animation_mode_mapping_get_type_once ();
		g_once_init_leave (&plank_animation_mode_mapping_type_id__once, plank_animation_mode_mapping_type_id);
	}
	return plank_animation_mode_mapping_type_id__once;
}

static gdouble
_plank_linear_plank_easing_func (gdouble t,
                                 gdouble d)
{
	gdouble result;
	result = plank_linear (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 298 "Easing.c"
}

static gdouble
_plank_ease_in_quad_plank_easing_func (gdouble t,
                                       gdouble d)
{
	gdouble result;
	result = plank_ease_in_quad (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 309 "Easing.c"
}

static gdouble
_plank_ease_out_quad_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_out_quad (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 320 "Easing.c"
}

static gdouble
_plank_ease_in_out_quad_plank_easing_func (gdouble t,
                                           gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_quad (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 331 "Easing.c"
}

static gdouble
_plank_ease_in_cubic_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_in_cubic (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 342 "Easing.c"
}

static gdouble
_plank_ease_out_cubic_plank_easing_func (gdouble t,
                                         gdouble d)
{
	gdouble result;
	result = plank_ease_out_cubic (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 353 "Easing.c"
}

static gdouble
_plank_ease_in_out_cubic_plank_easing_func (gdouble t,
                                            gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_cubic (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 364 "Easing.c"
}

static gdouble
_plank_ease_in_quart_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_in_quart (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 375 "Easing.c"
}

static gdouble
_plank_ease_out_quart_plank_easing_func (gdouble t,
                                         gdouble d)
{
	gdouble result;
	result = plank_ease_out_quart (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 386 "Easing.c"
}

static gdouble
_plank_ease_in_out_quart_plank_easing_func (gdouble t,
                                            gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_quart (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 397 "Easing.c"
}

static gdouble
_plank_ease_in_quint_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_in_quint (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 408 "Easing.c"
}

static gdouble
_plank_ease_out_quint_plank_easing_func (gdouble t,
                                         gdouble d)
{
	gdouble result;
	result = plank_ease_out_quint (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 419 "Easing.c"
}

static gdouble
_plank_ease_in_out_quint_plank_easing_func (gdouble t,
                                            gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_quint (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 430 "Easing.c"
}

static gdouble
_plank_ease_in_sine_plank_easing_func (gdouble t,
                                       gdouble d)
{
	gdouble result;
	result = plank_ease_in_sine (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 441 "Easing.c"
}

static gdouble
_plank_ease_out_sine_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_out_sine (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 452 "Easing.c"
}

static gdouble
_plank_ease_in_out_sine_plank_easing_func (gdouble t,
                                           gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_sine (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 463 "Easing.c"
}

static gdouble
_plank_ease_in_expo_plank_easing_func (gdouble t,
                                       gdouble d)
{
	gdouble result;
	result = plank_ease_in_expo (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 474 "Easing.c"
}

static gdouble
_plank_ease_out_expo_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_out_expo (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 485 "Easing.c"
}

static gdouble
_plank_ease_in_out_expo_plank_easing_func (gdouble t,
                                           gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_expo (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 496 "Easing.c"
}

static gdouble
_plank_ease_in_circ_plank_easing_func (gdouble t,
                                       gdouble d)
{
	gdouble result;
	result = plank_ease_in_circ (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 507 "Easing.c"
}

static gdouble
_plank_ease_out_circ_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_out_circ (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 518 "Easing.c"
}

static gdouble
_plank_ease_in_out_circ_plank_easing_func (gdouble t,
                                           gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_circ (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 529 "Easing.c"
}

static gdouble
_plank_ease_in_elastic_plank_easing_func (gdouble t,
                                          gdouble d)
{
	gdouble result;
	result = plank_ease_in_elastic (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 540 "Easing.c"
}

static gdouble
_plank_ease_out_elastic_plank_easing_func (gdouble t,
                                           gdouble d)
{
	gdouble result;
	result = plank_ease_out_elastic (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 551 "Easing.c"
}

static gdouble
_plank_ease_in_out_elastic_plank_easing_func (gdouble t,
                                              gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_elastic (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 562 "Easing.c"
}

static gdouble
_plank_ease_in_back_plank_easing_func (gdouble t,
                                       gdouble d)
{
	gdouble result;
	result = plank_ease_in_back (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 573 "Easing.c"
}

static gdouble
_plank_ease_out_back_plank_easing_func (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = plank_ease_out_back (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 584 "Easing.c"
}

static gdouble
_plank_ease_in_out_back_plank_easing_func (gdouble t,
                                           gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_back (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 595 "Easing.c"
}

static gdouble
_plank_ease_in_bounce_plank_easing_func (gdouble t,
                                         gdouble d)
{
	gdouble result;
	result = plank_ease_in_bounce (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 606 "Easing.c"
}

static gdouble
_plank_ease_out_bounce_plank_easing_func (gdouble t,
                                          gdouble d)
{
	gdouble result;
	result = plank_ease_out_bounce (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 617 "Easing.c"
}

static gdouble
_plank_ease_in_out_bounce_plank_easing_func (gdouble t,
                                             gdouble d)
{
	gdouble result;
	result = plank_ease_in_out_bounce (t, d);
#line 190 "../lib/Drawing/Easing.vala"
	return result;
#line 628 "Easing.c"
}

 G_GNUC_INTERNAL PlankEasingFunc
plank_easing_func_for_mode (PlankAnimationMode mode)
{
	PlankAnimationModeMapping* animation = NULL;
	PlankEasingFunc _tmp0_;
	PlankEasingFunc _tmp1_;
	PlankEasingFunc result;
#line 230 "../lib/Drawing/Easing.vala"
	animation = &PLANK_ANIMATION_MODES[mode];
#line 232 "../lib/Drawing/Easing.vala"
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
#line 233 "../lib/Drawing/Easing.vala"
	_tmp0_ = (*animation).func;
#line 233 "../lib/Drawing/Easing.vala"
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
#line 235 "../lib/Drawing/Easing.vala"
	_tmp1_ = (*animation).func;
#line 235 "../lib/Drawing/Easing.vala"
	result = _tmp1_;
#line 235 "../lib/Drawing/Easing.vala"
	return result;
#line 652 "Easing.c"
}

 G_GNUC_INTERNAL const gchar*
plank_easing_name_for_mode (PlankAnimationMode mode)
{
	PlankAnimationModeMapping* animation = NULL;
	PlankEasingFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* result;
#line 240 "../lib/Drawing/Easing.vala"
	animation = &PLANK_ANIMATION_MODES[mode];
#line 242 "../lib/Drawing/Easing.vala"
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
#line 243 "../lib/Drawing/Easing.vala"
	_tmp0_ = (*animation).func;
#line 243 "../lib/Drawing/Easing.vala"
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
#line 245 "../lib/Drawing/Easing.vala"
	_tmp1_ = (*animation).name;
#line 245 "../lib/Drawing/Easing.vala"
	result = _tmp1_;
#line 245 "../lib/Drawing/Easing.vala"
	return result;
#line 676 "Easing.c"
}

/**
 * Calculate an interpolated value for selected animation-mode, and given
 * elapsed time and total duration.
 *
 * @param mode animation-mode to be used
 * @param t elapsed time
 * @param d total duration
 * @return the interpolated value, between -1.0 and 2.0
 */
gdouble
plank_easing_for_mode (PlankAnimationMode mode,
                       gdouble t,
                       gdouble d)
{
	PlankAnimationModeMapping* animation = NULL;
	PlankEasingFunc _tmp0_;
	PlankEasingFunc _tmp1_;
	gdouble result;
#line 257 "../lib/Drawing/Easing.vala"
	_vala_return_val_if_fail ((t >= 0.0) && (d > 0.0), "t >= 0.0 && d > 0.0", 0.0);
#line 257 "../lib/Drawing/Easing.vala"
	_vala_return_val_if_fail (t <= d, "t <= d", 0.0);
#line 262 "../lib/Drawing/Easing.vala"
	animation = &PLANK_ANIMATION_MODES[mode];
#line 264 "../lib/Drawing/Easing.vala"
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
#line 265 "../lib/Drawing/Easing.vala"
	_tmp0_ = (*animation).func;
#line 265 "../lib/Drawing/Easing.vala"
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
#line 267 "../lib/Drawing/Easing.vala"
	_tmp1_ = (*animation).func;
#line 267 "../lib/Drawing/Easing.vala"
	result = _tmp1_ (t, d);
#line 267 "../lib/Drawing/Easing.vala"
	_vala_warn_if_fail ((result >= (-1.0)) && (result <= 2.0), "result >= -1.0 && result <= 2.0");
#line 267 "../lib/Drawing/Easing.vala"
	return result;
#line 717 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_linear (gdouble t,
              gdouble d)
{
	gdouble result;
#line 272 "../lib/Drawing/Easing.vala"
	result = t / d;
#line 272 "../lib/Drawing/Easing.vala"
	return result;
#line 729 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_quad (gdouble t,
                    gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 277 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 279 "../lib/Drawing/Easing.vala"
	result = p * p;
#line 279 "../lib/Drawing/Easing.vala"
	return result;
#line 744 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_quad (gdouble t,
                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 284 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 286 "../lib/Drawing/Easing.vala"
	result = ((-1.0) * p) * (p - 2);
#line 286 "../lib/Drawing/Easing.vala"
	return result;
#line 759 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_quad (gdouble t,
                        gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 291 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 293 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 294 "../lib/Drawing/Easing.vala"
		result = (0.5 * p) * p;
#line 294 "../lib/Drawing/Easing.vala"
		return result;
#line 776 "Easing.c"
	}
#line 296 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 1;
#line 298 "../lib/Drawing/Easing.vala"
	result = (-0.5) * ((p * (p - 2)) - 1);
#line 298 "../lib/Drawing/Easing.vala"
	return result;
#line 784 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_cubic (gdouble t,
                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 303 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 305 "../lib/Drawing/Easing.vala"
	result = (p * p) * p;
#line 305 "../lib/Drawing/Easing.vala"
	return result;
#line 799 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_cubic (gdouble t,
                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 310 "../lib/Drawing/Easing.vala"
	p = (t / d) - 1;
#line 312 "../lib/Drawing/Easing.vala"
	result = ((p * p) * p) + 1;
#line 312 "../lib/Drawing/Easing.vala"
	return result;
#line 814 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_cubic (gdouble t,
                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 317 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 319 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 320 "../lib/Drawing/Easing.vala"
		result = ((0.5 * p) * p) * p;
#line 320 "../lib/Drawing/Easing.vala"
		return result;
#line 831 "Easing.c"
	}
#line 322 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 2;
#line 324 "../lib/Drawing/Easing.vala"
	result = 0.5 * (((p * p) * p) + 2);
#line 324 "../lib/Drawing/Easing.vala"
	return result;
#line 839 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_quart (gdouble t,
                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 329 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 331 "../lib/Drawing/Easing.vala"
	result = ((p * p) * p) * p;
#line 331 "../lib/Drawing/Easing.vala"
	return result;
#line 854 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_quart (gdouble t,
                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 336 "../lib/Drawing/Easing.vala"
	p = (t / d) - 1;
#line 338 "../lib/Drawing/Easing.vala"
	result = (-1.0) * ((((p * p) * p) * p) - 1);
#line 338 "../lib/Drawing/Easing.vala"
	return result;
#line 869 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_quart (gdouble t,
                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 343 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 345 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 346 "../lib/Drawing/Easing.vala"
		result = (((0.5 * p) * p) * p) * p;
#line 346 "../lib/Drawing/Easing.vala"
		return result;
#line 886 "Easing.c"
	}
#line 348 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 2;
#line 350 "../lib/Drawing/Easing.vala"
	result = (-0.5) * ((((p * p) * p) * p) - 2);
#line 350 "../lib/Drawing/Easing.vala"
	return result;
#line 894 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_quint (gdouble t,
                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 355 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 357 "../lib/Drawing/Easing.vala"
	result = (((p * p) * p) * p) * p;
#line 357 "../lib/Drawing/Easing.vala"
	return result;
#line 909 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_quint (gdouble t,
                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 362 "../lib/Drawing/Easing.vala"
	p = (t / d) - 1;
#line 364 "../lib/Drawing/Easing.vala"
	result = ((((p * p) * p) * p) * p) + 1;
#line 364 "../lib/Drawing/Easing.vala"
	return result;
#line 924 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_quint (gdouble t,
                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 369 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 371 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 372 "../lib/Drawing/Easing.vala"
		result = ((((0.5 * p) * p) * p) * p) * p;
#line 372 "../lib/Drawing/Easing.vala"
		return result;
#line 941 "Easing.c"
	}
#line 374 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 2;
#line 376 "../lib/Drawing/Easing.vala"
	result = 0.5 * (((((p * p) * p) * p) * p) + 2);
#line 376 "../lib/Drawing/Easing.vala"
	return result;
#line 949 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_sine (gdouble t,
                    gdouble d)
{
	gdouble result;
#line 381 "../lib/Drawing/Easing.vala"
	result = ((-1.0) * cos ((t / d) * G_PI_2)) + 1.0;
#line 381 "../lib/Drawing/Easing.vala"
	return result;
#line 961 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_sine (gdouble t,
                     gdouble d)
{
	gdouble result;
#line 386 "../lib/Drawing/Easing.vala"
	result = sin ((t / d) * G_PI_2);
#line 386 "../lib/Drawing/Easing.vala"
	return result;
#line 973 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_sine (gdouble t,
                        gdouble d)
{
	gdouble result;
#line 391 "../lib/Drawing/Easing.vala"
	result = (-0.5) * (cos ((G_PI * t) / d) - 1);
#line 391 "../lib/Drawing/Easing.vala"
	return result;
#line 985 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_expo (gdouble t,
                    gdouble d)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 396 "../lib/Drawing/Easing.vala"
	if (t == ((gdouble) 0)) {
#line 396 "../lib/Drawing/Easing.vala"
		_tmp0_ = 0.0;
#line 998 "Easing.c"
	} else {
#line 396 "../lib/Drawing/Easing.vala"
		_tmp0_ = pow ((gdouble) 2, 10 * ((t / d) - 1));
#line 1002 "Easing.c"
	}
#line 396 "../lib/Drawing/Easing.vala"
	result = _tmp0_;
#line 396 "../lib/Drawing/Easing.vala"
	return result;
#line 1008 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_expo (gdouble t,
                     gdouble d)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 401 "../lib/Drawing/Easing.vala"
	if (t == d) {
#line 401 "../lib/Drawing/Easing.vala"
		_tmp0_ = 1.0;
#line 1021 "Easing.c"
	} else {
#line 401 "../lib/Drawing/Easing.vala"
		_tmp0_ = (-pow ((gdouble) 2, (-10 * t) / d)) + 1;
#line 1025 "Easing.c"
	}
#line 401 "../lib/Drawing/Easing.vala"
	result = _tmp0_;
#line 401 "../lib/Drawing/Easing.vala"
	return result;
#line 1031 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_expo (gdouble t,
                        gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 408 "../lib/Drawing/Easing.vala"
	if (t == ((gdouble) 0)) {
#line 409 "../lib/Drawing/Easing.vala"
		result = 0.0;
#line 409 "../lib/Drawing/Easing.vala"
		return result;
#line 1046 "Easing.c"
	}
#line 411 "../lib/Drawing/Easing.vala"
	if (t == d) {
#line 412 "../lib/Drawing/Easing.vala"
		result = 1.0;
#line 412 "../lib/Drawing/Easing.vala"
		return result;
#line 1054 "Easing.c"
	}
#line 414 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 416 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 417 "../lib/Drawing/Easing.vala"
		result = 0.5 * pow ((gdouble) 2, 10 * (p - 1));
#line 417 "../lib/Drawing/Easing.vala"
		return result;
#line 1064 "Easing.c"
	}
#line 419 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 1;
#line 421 "../lib/Drawing/Easing.vala"
	result = 0.5 * ((-pow ((gdouble) 2, -10 * p)) + 2);
#line 421 "../lib/Drawing/Easing.vala"
	return result;
#line 1072 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_circ (gdouble t,
                    gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 426 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 428 "../lib/Drawing/Easing.vala"
	result = (-1.0) * (sqrt (1 - (p * p)) - 1);
#line 428 "../lib/Drawing/Easing.vala"
	return result;
#line 1087 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_circ (gdouble t,
                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 433 "../lib/Drawing/Easing.vala"
	p = (t / d) - 1;
#line 435 "../lib/Drawing/Easing.vala"
	result = sqrt (1 - (p * p));
#line 435 "../lib/Drawing/Easing.vala"
	return result;
#line 1102 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_circ (gdouble t,
                        gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 440 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 442 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 443 "../lib/Drawing/Easing.vala"
		result = (-0.5) * (sqrt (1 - (p * p)) - 1);
#line 443 "../lib/Drawing/Easing.vala"
		return result;
#line 1119 "Easing.c"
	}
#line 445 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 2;
#line 447 "../lib/Drawing/Easing.vala"
	result = 0.5 * (sqrt (1 - (p * p)) + 1);
#line 447 "../lib/Drawing/Easing.vala"
	return result;
#line 1127 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_elastic (gdouble t,
                       gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
#line 452 "../lib/Drawing/Easing.vala"
	p = d * 0.3;
#line 453 "../lib/Drawing/Easing.vala"
	s = p / 4;
#line 454 "../lib/Drawing/Easing.vala"
	q = t / d;
#line 456 "../lib/Drawing/Easing.vala"
	if (q == ((gdouble) 1)) {
#line 457 "../lib/Drawing/Easing.vala"
		result = 1.0;
#line 457 "../lib/Drawing/Easing.vala"
		return result;
#line 1150 "Easing.c"
	}
#line 459 "../lib/Drawing/Easing.vala"
	q -= (gdouble) 1;
#line 461 "../lib/Drawing/Easing.vala"
	result = -(pow ((gdouble) 2, 10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p));
#line 461 "../lib/Drawing/Easing.vala"
	return result;
#line 1158 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_elastic (gdouble t,
                        gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
#line 466 "../lib/Drawing/Easing.vala"
	p = d * 0.3;
#line 467 "../lib/Drawing/Easing.vala"
	s = p / 4;
#line 468 "../lib/Drawing/Easing.vala"
	q = t / d;
#line 470 "../lib/Drawing/Easing.vala"
	if (q == ((gdouble) 1)) {
#line 471 "../lib/Drawing/Easing.vala"
		result = 1.0;
#line 471 "../lib/Drawing/Easing.vala"
		return result;
#line 1181 "Easing.c"
	}
#line 473 "../lib/Drawing/Easing.vala"
	result = (pow ((gdouble) 2, -10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p)) + 1.0;
#line 473 "../lib/Drawing/Easing.vala"
	return result;
#line 1187 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_elastic (gdouble t,
                           gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
#line 478 "../lib/Drawing/Easing.vala"
	p = d * (0.3 * 1.5);
#line 479 "../lib/Drawing/Easing.vala"
	s = p / 4;
#line 480 "../lib/Drawing/Easing.vala"
	q = t / (d / 2);
#line 482 "../lib/Drawing/Easing.vala"
	if (q == ((gdouble) 2)) {
#line 483 "../lib/Drawing/Easing.vala"
		result = 1.0;
#line 483 "../lib/Drawing/Easing.vala"
		return result;
#line 1210 "Easing.c"
	}
#line 485 "../lib/Drawing/Easing.vala"
	if (q < ((gdouble) 1)) {
#line 486 "../lib/Drawing/Easing.vala"
		q -= (gdouble) 1;
#line 488 "../lib/Drawing/Easing.vala"
		result = (-0.5) * (pow ((gdouble) 2, 10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p));
#line 488 "../lib/Drawing/Easing.vala"
		return result;
#line 1220 "Easing.c"
	} else {
#line 490 "../lib/Drawing/Easing.vala"
		q -= (gdouble) 1;
#line 492 "../lib/Drawing/Easing.vala"
		result = ((pow ((gdouble) 2, -10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p)) * 0.5) + 1.0;
#line 492 "../lib/Drawing/Easing.vala"
		return result;
#line 1228 "Easing.c"
	}
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_back (gdouble t,
                    gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 500 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 502 "../lib/Drawing/Easing.vala"
	result = (p * p) * (((1.70158 + 1) * p) - 1.70158);
#line 502 "../lib/Drawing/Easing.vala"
	return result;
#line 1244 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_back (gdouble t,
                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 507 "../lib/Drawing/Easing.vala"
	p = (t / d) - 1;
#line 509 "../lib/Drawing/Easing.vala"
	result = ((p * p) * (((1.70158 + 1) * p) + 1.70158)) + 1;
#line 509 "../lib/Drawing/Easing.vala"
	return result;
#line 1259 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_back (gdouble t,
                        gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble result;
#line 514 "../lib/Drawing/Easing.vala"
	p = t / (d / 2);
#line 515 "../lib/Drawing/Easing.vala"
	s = 1.70158 * 1.525;
#line 517 "../lib/Drawing/Easing.vala"
	if (p < ((gdouble) 1)) {
#line 518 "../lib/Drawing/Easing.vala"
		result = 0.5 * ((p * p) * (((s + 1) * p) - s));
#line 518 "../lib/Drawing/Easing.vala"
		return result;
#line 1279 "Easing.c"
	}
#line 520 "../lib/Drawing/Easing.vala"
	p -= (gdouble) 2;
#line 522 "../lib/Drawing/Easing.vala"
	result = 0.5 * (((p * p) * (((s + 1) * p) + s)) + 2);
#line 522 "../lib/Drawing/Easing.vala"
	return result;
#line 1287 "Easing.c"
}

 G_GNUC_INTERNAL inline gdouble
plank_ease_out_bounce_internal (gdouble t,
                                gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 527 "../lib/Drawing/Easing.vala"
	p = t / d;
#line 529 "../lib/Drawing/Easing.vala"
	if (p < (1 / 2.75)) {
#line 530 "../lib/Drawing/Easing.vala"
		result = (7.5625 * p) * p;
#line 530 "../lib/Drawing/Easing.vala"
		return result;
#line 1304 "Easing.c"
	} else {
#line 531 "../lib/Drawing/Easing.vala"
		if (p < (2 / 2.75)) {
#line 532 "../lib/Drawing/Easing.vala"
			p -= 1.5 / 2.75;
#line 534 "../lib/Drawing/Easing.vala"
			result = ((7.5625 * p) * p) + 0.75;
#line 534 "../lib/Drawing/Easing.vala"
			return result;
#line 1314 "Easing.c"
		} else {
#line 535 "../lib/Drawing/Easing.vala"
			if (p < (2.5 / 2.75)) {
#line 536 "../lib/Drawing/Easing.vala"
				p -= 2.25 / 2.75;
#line 538 "../lib/Drawing/Easing.vala"
				result = ((7.5625 * p) * p) + 0.9375;
#line 538 "../lib/Drawing/Easing.vala"
				return result;
#line 1324 "Easing.c"
			} else {
#line 540 "../lib/Drawing/Easing.vala"
				p -= 2.625 / 2.75;
#line 542 "../lib/Drawing/Easing.vala"
				result = ((7.5625 * p) * p) + 0.984375;
#line 542 "../lib/Drawing/Easing.vala"
				return result;
#line 1332 "Easing.c"
			}
		}
	}
}

 G_GNUC_INTERNAL inline gdouble
plank_ease_in_bounce_internal (gdouble t,
                               gdouble d)
{
	gdouble result;
#line 548 "../lib/Drawing/Easing.vala"
	result = 1.0 - plank_ease_out_bounce_internal (d - t, d);
#line 548 "../lib/Drawing/Easing.vala"
	return result;
#line 1347 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_bounce (gdouble t,
                      gdouble d)
{
	gdouble result;
#line 553 "../lib/Drawing/Easing.vala"
	result = plank_ease_in_bounce_internal (t, d);
#line 553 "../lib/Drawing/Easing.vala"
	return result;
#line 1359 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_out_bounce (gdouble t,
                       gdouble d)
{
	gdouble result;
#line 558 "../lib/Drawing/Easing.vala"
	result = plank_ease_out_bounce_internal (t, d);
#line 558 "../lib/Drawing/Easing.vala"
	return result;
#line 1371 "Easing.c"
}

 G_GNUC_INTERNAL gdouble
plank_ease_in_out_bounce (gdouble t,
                          gdouble d)
{
	gdouble result;
#line 563 "../lib/Drawing/Easing.vala"
	if (t < (d / 2)) {
#line 564 "../lib/Drawing/Easing.vala"
		result = plank_ease_in_bounce_internal (t * 2, d) * 0.5;
#line 564 "../lib/Drawing/Easing.vala"
		return result;
#line 1385 "Easing.c"
	} else {
#line 566 "../lib/Drawing/Easing.vala"
		result = (plank_ease_out_bounce_internal ((t * 2) - d, d) * 0.5) + (1.0 * 0.5);
#line 566 "../lib/Drawing/Easing.vala"
		return result;
#line 1391 "Easing.c"
	}
}

