/* DockItemProvider.c generated by valac 0.56.3, the Vala compiler
 * generated from DockItemProvider.vala, do not modify */

/**/
/*  Copyright (C) 2014 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	PLANK_DOCK_ITEM_PROVIDER_0_PROPERTY,
	PLANK_DOCK_ITEM_PROVIDER_NUM_PROPERTIES
};
static GParamSpec* plank_dock_item_provider_properties[PLANK_DOCK_ITEM_PROVIDER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer plank_dock_item_provider_parent_class = NULL;

static gboolean plank_dock_item_provider_real_item_exists_for_uri (PlankDockItemProvider* self,
                                                            const gchar* uri);
static PlankDockItem* plank_dock_item_provider_real_item_for_uri (PlankDockItemProvider* self,
                                                           const gchar* uri);
static gboolean plank_dock_item_provider_real_add_item_with_uri (PlankDockItemProvider* self,
                                                          const gchar* uri,
                                                          PlankDockItem* target);
static gboolean plank_dock_item_provider_real_can_accept_drop (PlankDockElement* base,
                                                        GeeArrayList* uris);
static gboolean plank_dock_item_provider_real_accept_drop (PlankDockElement* base,
                                                    GeeArrayList* uris);
static void plank_dock_item_provider_real_connect_element (PlankDockContainer* base,
                                                    PlankDockElement* element);
static void plank_dock_item_provider_handle_item_state_changed (PlankDockItemProvider* self);
static void _plank_dock_item_provider_handle_item_state_changed_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self);
static void _plank_dock_item_provider_handle_item_state_changed_plank_dock_element_needs_redraw (PlankDockElement* _sender,
                                                                                          gpointer self);
static void _plank_dock_item_provider_handle_item_deleted_plank_dock_item_deleted (PlankDockItem* _sender,
                                                                            gpointer self);
static void plank_dock_item_provider_real_disconnect_element (PlankDockContainer* base,
                                                       PlankDockElement* element);
static void plank_dock_item_provider_real_handle_item_deleted (PlankDockItemProvider* self,
                                                        PlankDockItem* item);
static gchar** plank_dock_item_provider_real_get_dockitem_filenames (PlankDockItemProvider* self,
                                                              gint* result_length1);
static GType plank_dock_item_provider_get_type_once (void);

/**
 * Creates a new container for dock items.
 */
PlankDockItemProvider*
plank_dock_item_provider_construct (GType object_type)
{
	PlankDockItemProvider * self = NULL;
#line 32 "../lib/Items/DockItemProvider.vala"
	self = (PlankDockItemProvider*) g_object_new (object_type, NULL);
#line 30 "../lib/Items/DockItemProvider.vala"
	return self;
#line 81 "DockItemProvider.c"
}

PlankDockItemProvider*
plank_dock_item_provider_new (void)
{
#line 30 "../lib/Items/DockItemProvider.vala"
	return plank_dock_item_provider_construct (PLANK_TYPE_DOCK_ITEM_PROVIDER);
#line 89 "DockItemProvider.c"
}

/**
 * Whether a dock item with the given URI exists in this provider.
 *
 * @param uri the URI to look for
 */
static gboolean
plank_dock_item_provider_real_item_exists_for_uri (PlankDockItemProvider* self,
                                                   const gchar* uri)
{
	PlankDockItem* _tmp0_;
	gboolean result;
#line 40 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 42 "../lib/Items/DockItemProvider.vala"
	_tmp0_ = plank_dock_item_provider_item_for_uri (self, uri);
#line 42 "../lib/Items/DockItemProvider.vala"
	result = _tmp0_ != NULL;
#line 42 "../lib/Items/DockItemProvider.vala"
	return result;
#line 111 "DockItemProvider.c"
}

gboolean
plank_dock_item_provider_item_exists_for_uri (PlankDockItemProvider* self,
                                              const gchar* uri)
{
	PlankDockItemProviderClass* _klass_;
#line 40 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../lib/Items/DockItemProvider.vala"
	_klass_ = PLANK_DOCK_ITEM_PROVIDER_GET_CLASS (self);
#line 40 "../lib/Items/DockItemProvider.vala"
	if (_klass_->item_exists_for_uri) {
#line 40 "../lib/Items/DockItemProvider.vala"
		return _klass_->item_exists_for_uri (self, uri);
#line 127 "DockItemProvider.c"
	}
#line 40 "../lib/Items/DockItemProvider.vala"
	return FALSE;
#line 131 "DockItemProvider.c"
}

/**
 * Get the dock item for the given URI if it exists or null.
 *
 * @param uri the URI to look for
 */
static PlankDockItem*
plank_dock_item_provider_real_item_for_uri (PlankDockItemProvider* self,
                                            const gchar* uri)
{
	PlankDockItem* result;
#line 50 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 146 "DockItemProvider.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp0_;
		gint _element_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _element_index = 0;
#line 52 "../lib/Items/DockItemProvider.vala"
		_tmp0_ = ((PlankDockContainer*) self)->internal_elements;
#line 52 "../lib/Items/DockItemProvider.vala"
		_element_list = _tmp0_;
#line 52 "../lib/Items/DockItemProvider.vala"
		_tmp1_ = _element_list;
#line 52 "../lib/Items/DockItemProvider.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 52 "../lib/Items/DockItemProvider.vala"
		_tmp3_ = _tmp2_;
#line 52 "../lib/Items/DockItemProvider.vala"
		_element_size = _tmp3_;
#line 52 "../lib/Items/DockItemProvider.vala"
		_element_index = -1;
#line 52 "../lib/Items/DockItemProvider.vala"
		while (TRUE) {
#line 171 "DockItemProvider.c"
			gint _tmp4_;
			gint _tmp5_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp8_;
			gboolean _tmp9_ = FALSE;
			PlankDockItem* _tmp10_;
#line 52 "../lib/Items/DockItemProvider.vala"
			_element_index = _element_index + 1;
#line 52 "../lib/Items/DockItemProvider.vala"
			_tmp4_ = _element_index;
#line 52 "../lib/Items/DockItemProvider.vala"
			_tmp5_ = _element_size;
#line 52 "../lib/Items/DockItemProvider.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 52 "../lib/Items/DockItemProvider.vala"
				break;
#line 191 "DockItemProvider.c"
			}
#line 52 "../lib/Items/DockItemProvider.vala"
			_tmp6_ = _element_list;
#line 52 "../lib/Items/DockItemProvider.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _element_index);
#line 52 "../lib/Items/DockItemProvider.vala"
			element = (PlankDockElement*) _tmp7_;
#line 53 "../lib/Items/DockItemProvider.vala"
			_tmp8_ = element;
#line 53 "../lib/Items/DockItemProvider.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp8_) ? ((PlankDockItem*) _tmp8_) : NULL;
#line 54 "../lib/Items/DockItemProvider.vala"
			_tmp10_ = item;
#line 54 "../lib/Items/DockItemProvider.vala"
			if (_tmp10_ != NULL) {
#line 207 "DockItemProvider.c"
				PlankDockItem* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
#line 54 "../lib/Items/DockItemProvider.vala"
				_tmp11_ = item;
#line 54 "../lib/Items/DockItemProvider.vala"
				_tmp12_ = plank_dock_item_get_Launcher (_tmp11_);
#line 54 "../lib/Items/DockItemProvider.vala"
				_tmp13_ = _tmp12_;
#line 54 "../lib/Items/DockItemProvider.vala"
				_tmp9_ = g_strcmp0 (_tmp13_, uri) == 0;
#line 219 "DockItemProvider.c"
			} else {
#line 54 "../lib/Items/DockItemProvider.vala"
				_tmp9_ = FALSE;
#line 223 "DockItemProvider.c"
			}
#line 54 "../lib/Items/DockItemProvider.vala"
			if (_tmp9_) {
#line 227 "DockItemProvider.c"
				PlankDockItem* _tmp14_;
#line 55 "../lib/Items/DockItemProvider.vala"
				_tmp14_ = item;
#line 55 "../lib/Items/DockItemProvider.vala"
				result = _tmp14_;
#line 55 "../lib/Items/DockItemProvider.vala"
				_g_object_unref0 (element);
#line 55 "../lib/Items/DockItemProvider.vala"
				return result;
#line 237 "DockItemProvider.c"
			}
#line 52 "../lib/Items/DockItemProvider.vala"
			_g_object_unref0 (element);
#line 241 "DockItemProvider.c"
		}
	}
#line 58 "../lib/Items/DockItemProvider.vala"
	result = NULL;
#line 58 "../lib/Items/DockItemProvider.vala"
	return result;
#line 248 "DockItemProvider.c"
}

PlankDockItem*
plank_dock_item_provider_item_for_uri (PlankDockItemProvider* self,
                                       const gchar* uri)
{
	PlankDockItemProviderClass* _klass_;
#line 50 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../lib/Items/DockItemProvider.vala"
	_klass_ = PLANK_DOCK_ITEM_PROVIDER_GET_CLASS (self);
#line 50 "../lib/Items/DockItemProvider.vala"
	if (_klass_->item_for_uri) {
#line 50 "../lib/Items/DockItemProvider.vala"
		return _klass_->item_for_uri (self, uri);
#line 264 "DockItemProvider.c"
	}
#line 50 "../lib/Items/DockItemProvider.vala"
	return NULL;
#line 268 "DockItemProvider.c"
}

/**
 * Adds a dock item with the given URI to the collection.
 *
 * @param uri the URI to add a dock item for
 * @param target an existing item where to put this new one at
 * @return whether adding the URI was successful
 */
static gboolean
plank_dock_item_provider_real_add_item_with_uri (PlankDockItemProvider* self,
                                                 const gchar* uri,
                                                 PlankDockItem* target)
{
	gboolean result;
#line 68 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 70 "../lib/Items/DockItemProvider.vala"
	g_warning ("DockItemProvider.vala:70: Not implemented by default");
#line 72 "../lib/Items/DockItemProvider.vala"
	result = FALSE;
#line 72 "../lib/Items/DockItemProvider.vala"
	return result;
#line 292 "DockItemProvider.c"
}

gboolean
plank_dock_item_provider_add_item_with_uri (PlankDockItemProvider* self,
                                            const gchar* uri,
                                            PlankDockItem* target)
{
	PlankDockItemProviderClass* _klass_;
#line 68 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 68 "../lib/Items/DockItemProvider.vala"
	_klass_ = PLANK_DOCK_ITEM_PROVIDER_GET_CLASS (self);
#line 68 "../lib/Items/DockItemProvider.vala"
	if (_klass_->add_item_with_uri) {
#line 68 "../lib/Items/DockItemProvider.vala"
		return _klass_->add_item_with_uri (self, uri, target);
#line 309 "DockItemProvider.c"
	}
#line 68 "../lib/Items/DockItemProvider.vala"
	return FALSE;
#line 313 "DockItemProvider.c"
}

static gboolean
plank_dock_item_provider_real_can_accept_drop (PlankDockElement* base,
                                               GeeArrayList* uris)
{
	PlankDockItemProvider * self;
	gboolean result;
#line 75 "../lib/Items/DockItemProvider.vala"
	self = (PlankDockItemProvider*) base;
#line 75 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (uris != NULL, FALSE);
#line 326 "DockItemProvider.c"
	{
		GeeArrayList* _uri_list = NULL;
		gint _uri_size = 0;
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _uri_index = 0;
#line 77 "../lib/Items/DockItemProvider.vala"
		_uri_list = uris;
#line 77 "../lib/Items/DockItemProvider.vala"
		_tmp0_ = _uri_list;
#line 77 "../lib/Items/DockItemProvider.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 77 "../lib/Items/DockItemProvider.vala"
		_tmp2_ = _tmp1_;
#line 77 "../lib/Items/DockItemProvider.vala"
		_uri_size = _tmp2_;
#line 77 "../lib/Items/DockItemProvider.vala"
		_uri_index = -1;
#line 77 "../lib/Items/DockItemProvider.vala"
		while (TRUE) {
#line 348 "DockItemProvider.c"
			gint _tmp3_;
			gint _tmp4_;
			gchar* uri = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			const gchar* _tmp7_;
#line 77 "../lib/Items/DockItemProvider.vala"
			_uri_index = _uri_index + 1;
#line 77 "../lib/Items/DockItemProvider.vala"
			_tmp3_ = _uri_index;
#line 77 "../lib/Items/DockItemProvider.vala"
			_tmp4_ = _uri_size;
#line 77 "../lib/Items/DockItemProvider.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 77 "../lib/Items/DockItemProvider.vala"
				break;
#line 365 "DockItemProvider.c"
			}
#line 77 "../lib/Items/DockItemProvider.vala"
			_tmp5_ = _uri_list;
#line 77 "../lib/Items/DockItemProvider.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _uri_index);
#line 77 "../lib/Items/DockItemProvider.vala"
			uri = (gchar*) _tmp6_;
#line 78 "../lib/Items/DockItemProvider.vala"
			_tmp7_ = uri;
#line 78 "../lib/Items/DockItemProvider.vala"
			if (!plank_dock_item_provider_item_exists_for_uri (self, _tmp7_)) {
#line 79 "../lib/Items/DockItemProvider.vala"
				result = TRUE;
#line 79 "../lib/Items/DockItemProvider.vala"
				_g_free0 (uri);
#line 79 "../lib/Items/DockItemProvider.vala"
				return result;
#line 383 "DockItemProvider.c"
			}
#line 77 "../lib/Items/DockItemProvider.vala"
			_g_free0 (uri);
#line 387 "DockItemProvider.c"
		}
	}
#line 81 "../lib/Items/DockItemProvider.vala"
	result = FALSE;
#line 81 "../lib/Items/DockItemProvider.vala"
	return result;
#line 394 "DockItemProvider.c"
}

static gboolean
plank_dock_item_provider_real_accept_drop (PlankDockElement* base,
                                           GeeArrayList* uris)
{
	PlankDockItemProvider * self;
	gboolean _result_ = FALSE;
	PlankDockItem* target_item = NULL;
	PlankDockController* controller = NULL;
	PlankDockController* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PlankDockController* _tmp2_;
	gboolean result;
#line 84 "../lib/Items/DockItemProvider.vala"
	self = (PlankDockItemProvider*) base;
#line 84 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (uris != NULL, FALSE);
#line 86 "../lib/Items/DockItemProvider.vala"
	_result_ = FALSE;
#line 88 "../lib/Items/DockItemProvider.vala"
	target_item = NULL;
#line 89 "../lib/Items/DockItemProvider.vala"
	_tmp0_ = plank_dock_element_get_dock ((PlankDockElement*) self);
#line 89 "../lib/Items/DockItemProvider.vala"
	controller = _tmp0_;
#line 90 "../lib/Items/DockItemProvider.vala"
	_tmp2_ = controller;
#line 90 "../lib/Items/DockItemProvider.vala"
	if (_tmp2_ != NULL) {
#line 425 "DockItemProvider.c"
		PlankDockController* _tmp3_;
		PlankDockWindow* _tmp4_;
		PlankDockWindow* _tmp5_;
		PlankDockItemProvider* _tmp6_;
		PlankDockItemProvider* _tmp7_;
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp3_ = controller;
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp5_ = _tmp4_;
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp6_ = plank_dock_window_get_HoveredItemProvider (_tmp5_);
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp7_ = _tmp6_;
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp1_ = _tmp7_ == self;
#line 443 "DockItemProvider.c"
	} else {
#line 90 "../lib/Items/DockItemProvider.vala"
		_tmp1_ = FALSE;
#line 447 "DockItemProvider.c"
	}
#line 90 "../lib/Items/DockItemProvider.vala"
	if (_tmp1_) {
#line 451 "DockItemProvider.c"
		PlankDockController* _tmp8_;
		PlankPositionManager* _tmp9_;
		PlankPositionManager* _tmp10_;
		PlankDockItem* _tmp11_;
#line 91 "../lib/Items/DockItemProvider.vala"
		_tmp8_ = controller;
#line 91 "../lib/Items/DockItemProvider.vala"
		_tmp9_ = plank_dock_controller_get_position_manager (_tmp8_);
#line 91 "../lib/Items/DockItemProvider.vala"
		_tmp10_ = _tmp9_;
#line 91 "../lib/Items/DockItemProvider.vala"
		_tmp11_ = plank_position_manager_get_current_target_item (_tmp10_, (PlankDockContainer*) self);
#line 91 "../lib/Items/DockItemProvider.vala"
		target_item = _tmp11_;
#line 466 "DockItemProvider.c"
	}
	{
		GeeArrayList* _uri_list = NULL;
		gint _uri_size = 0;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _uri_index = 0;
#line 94 "../lib/Items/DockItemProvider.vala"
		_uri_list = uris;
#line 94 "../lib/Items/DockItemProvider.vala"
		_tmp12_ = _uri_list;
#line 94 "../lib/Items/DockItemProvider.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 94 "../lib/Items/DockItemProvider.vala"
		_tmp14_ = _tmp13_;
#line 94 "../lib/Items/DockItemProvider.vala"
		_uri_size = _tmp14_;
#line 94 "../lib/Items/DockItemProvider.vala"
		_uri_index = -1;
#line 94 "../lib/Items/DockItemProvider.vala"
		while (TRUE) {
#line 489 "DockItemProvider.c"
			gint _tmp15_;
			gint _tmp16_;
			gchar* uri = NULL;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			const gchar* _tmp19_;
#line 94 "../lib/Items/DockItemProvider.vala"
			_uri_index = _uri_index + 1;
#line 94 "../lib/Items/DockItemProvider.vala"
			_tmp15_ = _uri_index;
#line 94 "../lib/Items/DockItemProvider.vala"
			_tmp16_ = _uri_size;
#line 94 "../lib/Items/DockItemProvider.vala"
			if (!(_tmp15_ < _tmp16_)) {
#line 94 "../lib/Items/DockItemProvider.vala"
				break;
#line 506 "DockItemProvider.c"
			}
#line 94 "../lib/Items/DockItemProvider.vala"
			_tmp17_ = _uri_list;
#line 94 "../lib/Items/DockItemProvider.vala"
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _uri_index);
#line 94 "../lib/Items/DockItemProvider.vala"
			uri = (gchar*) _tmp18_;
#line 95 "../lib/Items/DockItemProvider.vala"
			_tmp19_ = uri;
#line 95 "../lib/Items/DockItemProvider.vala"
			if (!plank_dock_item_provider_item_exists_for_uri (self, _tmp19_)) {
#line 518 "DockItemProvider.c"
				const gchar* _tmp20_;
				PlankDockItem* _tmp21_;
#line 96 "../lib/Items/DockItemProvider.vala"
				_tmp20_ = uri;
#line 96 "../lib/Items/DockItemProvider.vala"
				_tmp21_ = target_item;
#line 96 "../lib/Items/DockItemProvider.vala"
				plank_dock_item_provider_add_item_with_uri (self, _tmp20_, _tmp21_);
#line 97 "../lib/Items/DockItemProvider.vala"
				_result_ = TRUE;
#line 529 "DockItemProvider.c"
			}
#line 94 "../lib/Items/DockItemProvider.vala"
			_g_free0 (uri);
#line 533 "DockItemProvider.c"
		}
	}
#line 101 "../lib/Items/DockItemProvider.vala"
	result = _result_;
#line 101 "../lib/Items/DockItemProvider.vala"
	return result;
#line 540 "DockItemProvider.c"
}

static void
_plank_dock_item_provider_handle_item_state_changed_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self)
{
#line 110 "../lib/Items/DockItemProvider.vala"
	plank_dock_item_provider_handle_item_state_changed ((PlankDockItemProvider*) self);
#line 550 "DockItemProvider.c"
}

static void
_plank_dock_item_provider_handle_item_state_changed_plank_dock_element_needs_redraw (PlankDockElement* _sender,
                                                                                     gpointer self)
{
#line 113 "../lib/Items/DockItemProvider.vala"
	plank_dock_item_provider_handle_item_state_changed ((PlankDockItemProvider*) self);
#line 559 "DockItemProvider.c"
}

static void
_plank_dock_item_provider_handle_item_deleted_plank_dock_item_deleted (PlankDockItem* _sender,
                                                                       gpointer self)
{
#line 114 "../lib/Items/DockItemProvider.vala"
	plank_dock_item_provider_handle_item_deleted ((PlankDockItemProvider*) self, _sender);
#line 568 "DockItemProvider.c"
}

static void
plank_dock_item_provider_real_connect_element (PlankDockContainer* base,
                                               PlankDockElement* element)
{
	PlankDockItemProvider * self;
	PlankDockItem* item = NULL;
	PlankDockItem* _tmp0_;
	PlankDockItem* _tmp1_;
	PlankDockItem* _tmp2_;
	PlankDockItem* _tmp3_;
	PlankDockItem* _tmp4_;
	PlankDockItem* _tmp5_;
#line 104 "../lib/Items/DockItemProvider.vala"
	self = (PlankDockItemProvider*) base;
#line 104 "../lib/Items/DockItemProvider.vala"
	g_return_if_fail (element != NULL);
#line 106 "../lib/Items/DockItemProvider.vala"
	item = PLANK_IS_DOCK_ITEM (element) ? ((PlankDockItem*) element) : NULL;
#line 107 "../lib/Items/DockItemProvider.vala"
	_tmp0_ = item;
#line 107 "../lib/Items/DockItemProvider.vala"
	if (_tmp0_ == NULL) {
#line 108 "../lib/Items/DockItemProvider.vala"
		return;
#line 595 "DockItemProvider.c"
	}
#line 110 "../lib/Items/DockItemProvider.vala"
	_tmp1_ = item;
#line 110 "../lib/Items/DockItemProvider.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::Indicator", (GCallback) _plank_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
#line 111 "../lib/Items/DockItemProvider.vala"
	_tmp2_ = item;
#line 111 "../lib/Items/DockItemProvider.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::State", (GCallback) _plank_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
#line 112 "../lib/Items/DockItemProvider.vala"
	_tmp3_ = item;
#line 112 "../lib/Items/DockItemProvider.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::LastClicked", (GCallback) _plank_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
#line 113 "../lib/Items/DockItemProvider.vala"
	_tmp4_ = item;
#line 113 "../lib/Items/DockItemProvider.vala"
	g_signal_connect_object ((PlankDockElement*) _tmp4_, "needs-redraw", (GCallback) _plank_dock_item_provider_handle_item_state_changed_plank_dock_element_needs_redraw, self, 0);
#line 114 "../lib/Items/DockItemProvider.vala"
	_tmp5_ = item;
#line 114 "../lib/Items/DockItemProvider.vala"
	g_signal_connect_object (_tmp5_, "deleted", (GCallback) _plank_dock_item_provider_handle_item_deleted_plank_dock_item_deleted, self, 0);
#line 617 "DockItemProvider.c"
}

static void
plank_dock_item_provider_real_disconnect_element (PlankDockContainer* base,
                                                  PlankDockElement* element)
{
	PlankDockItemProvider * self;
	PlankDockItem* item = NULL;
	PlankDockItem* _tmp0_;
	PlankDockItem* _tmp1_;
	guint _tmp2_;
	GQuark _tmp3_;
	PlankDockItem* _tmp4_;
	guint _tmp5_;
	GQuark _tmp6_;
	PlankDockItem* _tmp7_;
	guint _tmp8_;
	GQuark _tmp9_;
	PlankDockItem* _tmp10_;
	guint _tmp11_;
	PlankDockItem* _tmp12_;
	guint _tmp13_;
#line 117 "../lib/Items/DockItemProvider.vala"
	self = (PlankDockItemProvider*) base;
#line 117 "../lib/Items/DockItemProvider.vala"
	g_return_if_fail (element != NULL);
#line 119 "../lib/Items/DockItemProvider.vala"
	item = PLANK_IS_DOCK_ITEM (element) ? ((PlankDockItem*) element) : NULL;
#line 120 "../lib/Items/DockItemProvider.vala"
	_tmp0_ = item;
#line 120 "../lib/Items/DockItemProvider.vala"
	if (_tmp0_ == NULL) {
#line 121 "../lib/Items/DockItemProvider.vala"
		return;
#line 652 "DockItemProvider.c"
	}
#line 123 "../lib/Items/DockItemProvider.vala"
	_tmp1_ = item;
#line 123 "../lib/Items/DockItemProvider.vala"
	g_signal_parse_name ("notify::Indicator", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
#line 123 "../lib/Items/DockItemProvider.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _plank_dock_item_provider_handle_item_state_changed_g_object_notify, self);
#line 124 "../lib/Items/DockItemProvider.vala"
	_tmp4_ = item;
#line 124 "../lib/Items/DockItemProvider.vala"
	g_signal_parse_name ("notify::State", G_TYPE_OBJECT, &_tmp5_, &_tmp6_, TRUE);
#line 124 "../lib/Items/DockItemProvider.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, _tmp6_, NULL, (GCallback) _plank_dock_item_provider_handle_item_state_changed_g_object_notify, self);
#line 125 "../lib/Items/DockItemProvider.vala"
	_tmp7_ = item;
#line 125 "../lib/Items/DockItemProvider.vala"
	g_signal_parse_name ("notify::LastClicked", G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
#line 125 "../lib/Items/DockItemProvider.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _plank_dock_item_provider_handle_item_state_changed_g_object_notify, self);
#line 126 "../lib/Items/DockItemProvider.vala"
	_tmp10_ = item;
#line 126 "../lib/Items/DockItemProvider.vala"
	g_signal_parse_name ("needs-redraw", PLANK_TYPE_DOCK_ELEMENT, &_tmp11_, NULL, FALSE);
#line 126 "../lib/Items/DockItemProvider.vala"
	g_signal_handlers_disconnect_matched ((PlankDockElement*) _tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _plank_dock_item_provider_handle_item_state_changed_plank_dock_element_needs_redraw, self);
#line 127 "../lib/Items/DockItemProvider.vala"
	_tmp12_ = item;
#line 127 "../lib/Items/DockItemProvider.vala"
	g_signal_parse_name ("deleted", PLANK_TYPE_DOCK_ITEM, &_tmp13_, NULL, FALSE);
#line 127 "../lib/Items/DockItemProvider.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _plank_dock_item_provider_handle_item_deleted_plank_dock_item_deleted, self);
#line 684 "DockItemProvider.c"
}

static void
plank_dock_item_provider_handle_item_state_changed (PlankDockItemProvider* self)
{
#line 130 "../lib/Items/DockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 132 "../lib/Items/DockItemProvider.vala"
	g_signal_emit_by_name ((PlankDockContainer*) self, "states-changed");
#line 694 "DockItemProvider.c"
}

static void
plank_dock_item_provider_real_handle_item_deleted (PlankDockItemProvider* self,
                                                   PlankDockItem* item)
{
#line 135 "../lib/Items/DockItemProvider.vala"
	g_return_if_fail (item != NULL);
#line 137 "../lib/Items/DockItemProvider.vala"
	plank_dock_container_remove ((PlankDockContainer*) self, (PlankDockElement*) item);
#line 705 "DockItemProvider.c"
}

void
plank_dock_item_provider_handle_item_deleted (PlankDockItemProvider* self,
                                              PlankDockItem* item)
{
	PlankDockItemProviderClass* _klass_;
#line 135 "../lib/Items/DockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 135 "../lib/Items/DockItemProvider.vala"
	_klass_ = PLANK_DOCK_ITEM_PROVIDER_GET_CLASS (self);
#line 135 "../lib/Items/DockItemProvider.vala"
	if (_klass_->handle_item_deleted) {
#line 135 "../lib/Items/DockItemProvider.vala"
		_klass_->handle_item_deleted (self, item);
#line 721 "DockItemProvider.c"
	}
}

/**
 * Get ordered array of dockitem-filenames handled by this provider
 *
 * @return an ordered array of strings containing all basenames
 */
static gchar**
plank_dock_item_provider_real_get_dockitem_filenames (PlankDockItemProvider* self,
                                                      gint* result_length1)
{
	GeeArrayList* item_list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp20_;
	gint _tmp21_ = 0;
	gpointer* _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gchar** result;
#line 147 "../lib/Items/DockItemProvider.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 147 "../lib/Items/DockItemProvider.vala"
	item_list = _tmp0_;
#line 746 "DockItemProvider.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp1_;
		gint _element_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _element_index = 0;
#line 149 "../lib/Items/DockItemProvider.vala"
		_tmp1_ = ((PlankDockContainer*) self)->internal_elements;
#line 149 "../lib/Items/DockItemProvider.vala"
		_element_list = _tmp1_;
#line 149 "../lib/Items/DockItemProvider.vala"
		_tmp2_ = _element_list;
#line 149 "../lib/Items/DockItemProvider.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 149 "../lib/Items/DockItemProvider.vala"
		_tmp4_ = _tmp3_;
#line 149 "../lib/Items/DockItemProvider.vala"
		_element_size = _tmp4_;
#line 149 "../lib/Items/DockItemProvider.vala"
		_element_index = -1;
#line 149 "../lib/Items/DockItemProvider.vala"
		while (TRUE) {
#line 771 "DockItemProvider.c"
			gint _tmp5_;
			gint _tmp6_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp9_;
			PlankDockItem* _tmp10_;
			gchar* dock_item_filename = NULL;
			PlankDockItem* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 149 "../lib/Items/DockItemProvider.vala"
			_element_index = _element_index + 1;
#line 149 "../lib/Items/DockItemProvider.vala"
			_tmp5_ = _element_index;
#line 149 "../lib/Items/DockItemProvider.vala"
			_tmp6_ = _element_size;
#line 149 "../lib/Items/DockItemProvider.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 149 "../lib/Items/DockItemProvider.vala"
				break;
#line 797 "DockItemProvider.c"
			}
#line 149 "../lib/Items/DockItemProvider.vala"
			_tmp7_ = _element_list;
#line 149 "../lib/Items/DockItemProvider.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _element_index);
#line 149 "../lib/Items/DockItemProvider.vala"
			element = (PlankDockElement*) _tmp8_;
#line 150 "../lib/Items/DockItemProvider.vala"
			_tmp9_ = element;
#line 150 "../lib/Items/DockItemProvider.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp9_) ? ((PlankDockItem*) _tmp9_) : NULL;
#line 151 "../lib/Items/DockItemProvider.vala"
			_tmp10_ = item;
#line 151 "../lib/Items/DockItemProvider.vala"
			if (_tmp10_ == NULL) {
#line 152 "../lib/Items/DockItemProvider.vala"
				_g_object_unref0 (element);
#line 152 "../lib/Items/DockItemProvider.vala"
				continue;
#line 817 "DockItemProvider.c"
			}
#line 154 "../lib/Items/DockItemProvider.vala"
			_tmp11_ = item;
#line 154 "../lib/Items/DockItemProvider.vala"
			_tmp12_ = plank_dock_item_get_DockItemFilename (_tmp11_);
#line 154 "../lib/Items/DockItemProvider.vala"
			_tmp13_ = _tmp12_;
#line 154 "../lib/Items/DockItemProvider.vala"
			dock_item_filename = _tmp13_;
#line 155 "../lib/Items/DockItemProvider.vala"
			_tmp14_ = dock_item_filename;
#line 155 "../lib/Items/DockItemProvider.vala"
			_tmp15_ = strlen (_tmp14_);
#line 155 "../lib/Items/DockItemProvider.vala"
			_tmp16_ = _tmp15_;
#line 155 "../lib/Items/DockItemProvider.vala"
			if (_tmp16_ > 0) {
#line 835 "DockItemProvider.c"
				GeeArrayList* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 156 "../lib/Items/DockItemProvider.vala"
				_tmp17_ = item_list;
#line 156 "../lib/Items/DockItemProvider.vala"
				_tmp18_ = dock_item_filename;
#line 156 "../lib/Items/DockItemProvider.vala"
				dock_item_filename = NULL;
#line 156 "../lib/Items/DockItemProvider.vala"
				_tmp19_ = _tmp18_;
#line 156 "../lib/Items/DockItemProvider.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp19_);
#line 156 "../lib/Items/DockItemProvider.vala"
				_g_free0 (_tmp19_);
#line 851 "DockItemProvider.c"
			}
#line 149 "../lib/Items/DockItemProvider.vala"
			_g_free0 (dock_item_filename);
#line 149 "../lib/Items/DockItemProvider.vala"
			_g_object_unref0 (element);
#line 857 "DockItemProvider.c"
		}
	}
#line 159 "../lib/Items/DockItemProvider.vala"
	_tmp20_ = item_list;
#line 159 "../lib/Items/DockItemProvider.vala"
	_tmp22_ = gee_collection_to_array ((GeeCollection*) _tmp20_, &_tmp21_);
#line 159 "../lib/Items/DockItemProvider.vala"
	_tmp23_ = _tmp22_;
#line 159 "../lib/Items/DockItemProvider.vala"
	_tmp23__length1 = _tmp21_;
#line 159 "../lib/Items/DockItemProvider.vala"
	if (result_length1) {
#line 159 "../lib/Items/DockItemProvider.vala"
		*result_length1 = _tmp23__length1;
#line 872 "DockItemProvider.c"
	}
#line 159 "../lib/Items/DockItemProvider.vala"
	result = _tmp23_;
#line 159 "../lib/Items/DockItemProvider.vala"
	_g_object_unref0 (item_list);
#line 159 "../lib/Items/DockItemProvider.vala"
	return result;
#line 880 "DockItemProvider.c"
}

gchar**
plank_dock_item_provider_get_dockitem_filenames (PlankDockItemProvider* self,
                                                 gint* result_length1)
{
	PlankDockItemProviderClass* _klass_;
#line 145 "../lib/Items/DockItemProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../lib/Items/DockItemProvider.vala"
	_klass_ = PLANK_DOCK_ITEM_PROVIDER_GET_CLASS (self);
#line 145 "../lib/Items/DockItemProvider.vala"
	if (_klass_->get_dockitem_filenames) {
#line 145 "../lib/Items/DockItemProvider.vala"
		return _klass_->get_dockitem_filenames (self, result_length1);
#line 896 "DockItemProvider.c"
	}
#line 145 "../lib/Items/DockItemProvider.vala"
	return NULL;
#line 900 "DockItemProvider.c"
}

static void
plank_dock_item_provider_class_init (PlankDockItemProviderClass * klass,
                                     gpointer klass_data)
{
#line 25 "../lib/Items/DockItemProvider.vala"
	plank_dock_item_provider_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->item_exists_for_uri = (gboolean (*) (PlankDockItemProvider*, const gchar*)) plank_dock_item_provider_real_item_exists_for_uri;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->item_for_uri = (PlankDockItem* (*) (PlankDockItemProvider*, const gchar*)) plank_dock_item_provider_real_item_for_uri;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->add_item_with_uri = (gboolean (*) (PlankDockItemProvider*, const gchar*, PlankDockItem*)) plank_dock_item_provider_real_add_item_with_uri;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockElementClass *) klass)->can_accept_drop = (gboolean (*) (PlankDockElement*, GeeArrayList*)) plank_dock_item_provider_real_can_accept_drop;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockElementClass *) klass)->accept_drop = (gboolean (*) (PlankDockElement*, GeeArrayList*)) plank_dock_item_provider_real_accept_drop;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockContainerClass *) klass)->connect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_dock_item_provider_real_connect_element;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockContainerClass *) klass)->disconnect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_dock_item_provider_real_disconnect_element;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->handle_item_deleted = (void (*) (PlankDockItemProvider*, PlankDockItem*)) plank_dock_item_provider_real_handle_item_deleted;
#line 25 "../lib/Items/DockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->get_dockitem_filenames = (gchar** (*) (PlankDockItemProvider*, gint*)) plank_dock_item_provider_real_get_dockitem_filenames;
#line 927 "DockItemProvider.c"
}

static void
plank_dock_item_provider_instance_init (PlankDockItemProvider * self,
                                        gpointer klass)
{
}

/**
 * A container and controller class for managing dock items.
 */
static GType
plank_dock_item_provider_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockItemProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_item_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockItemProvider), 0, (GInstanceInitFunc) plank_dock_item_provider_instance_init, NULL };
	GType plank_dock_item_provider_type_id;
	plank_dock_item_provider_type_id = g_type_register_static (PLANK_TYPE_DOCK_CONTAINER, "PlankDockItemProvider", &g_define_type_info, 0);
	return plank_dock_item_provider_type_id;
}

GType
plank_dock_item_provider_get_type (void)
{
	static volatile gsize plank_dock_item_provider_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_item_provider_type_id__once)) {
		GType plank_dock_item_provider_type_id;
		plank_dock_item_provider_type_id = plank_dock_item_provider_get_type_once ();
		g_once_init_leave (&plank_dock_item_provider_type_id__once, plank_dock_item_provider_type_id);
	}
	return plank_dock_item_provider_type_id__once;
}

