/* CompositedWindow.c generated by valac 0.56.3, the Vala compiler
 * generated from CompositedWindow.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>

enum  {
	PLANK_COMPOSITED_WINDOW_0_PROPERTY,
	PLANK_COMPOSITED_WINDOW_NUM_PROPERTIES
};
static GParamSpec* plank_composited_window_properties[PLANK_COMPOSITED_WINDOW_NUM_PROPERTIES];

static gpointer plank_composited_window_parent_class = NULL;

static gboolean plank_composited_window_real_draw (GtkWidget* base,
                                            cairo_t* cr);
static GObject * plank_composited_window_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static GType plank_composited_window_get_type_once (void);

PlankCompositedWindow*
plank_composited_window_construct (GType object_type)
{
	PlankCompositedWindow * self = NULL;
#line 30 "../lib/Widgets/CompositedWindow.vala"
	self = (PlankCompositedWindow*) g_object_new (object_type, "type", GTK_WINDOW_TOPLEVEL, NULL);
#line 28 "../lib/Widgets/CompositedWindow.vala"
	return self;
#line 54 "CompositedWindow.c"
}

PlankCompositedWindow*
plank_composited_window_new (void)
{
#line 28 "../lib/Widgets/CompositedWindow.vala"
	return plank_composited_window_construct (PLANK_TYPE_COMPOSITED_WINDOW);
#line 62 "CompositedWindow.c"
}

PlankCompositedWindow*
plank_composited_window_construct_with_type (GType object_type,
                                             GtkWindowType window_type)
{
	PlankCompositedWindow * self = NULL;
#line 35 "../lib/Widgets/CompositedWindow.vala"
	self = (PlankCompositedWindow*) g_object_new (object_type, "type", window_type, NULL);
#line 33 "../lib/Widgets/CompositedWindow.vala"
	return self;
#line 74 "CompositedWindow.c"
}

PlankCompositedWindow*
plank_composited_window_new_with_type (GtkWindowType window_type)
{
#line 33 "../lib/Widgets/CompositedWindow.vala"
	return plank_composited_window_construct_with_type (PLANK_TYPE_COMPOSITED_WINDOW, window_type);
#line 82 "CompositedWindow.c"
}

static gboolean
plank_composited_window_real_draw (GtkWidget* base,
                                   cairo_t* cr)
{
	PlankCompositedWindow * self;
	gboolean result;
#line 49 "../lib/Widgets/CompositedWindow.vala"
	self = (PlankCompositedWindow*) base;
#line 49 "../lib/Widgets/CompositedWindow.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 51 "../lib/Widgets/CompositedWindow.vala"
	cairo_save (cr);
#line 52 "../lib/Widgets/CompositedWindow.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
#line 53 "../lib/Widgets/CompositedWindow.vala"
	cairo_paint (cr);
#line 54 "../lib/Widgets/CompositedWindow.vala"
	cairo_restore (cr);
#line 56 "../lib/Widgets/CompositedWindow.vala"
	result = GDK_EVENT_STOP;
#line 56 "../lib/Widgets/CompositedWindow.vala"
	return result;
#line 107 "CompositedWindow.c"
}

static GObject *
plank_composited_window_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankCompositedWindow * self;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_;
	GdkVisual* _tmp1_ = NULL;
	GdkScreen* _tmp2_;
	GdkVisual* _tmp3_;
#line 38 "../lib/Widgets/CompositedWindow.vala"
	parent_class = G_OBJECT_CLASS (plank_composited_window_parent_class);
#line 38 "../lib/Widgets/CompositedWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../lib/Widgets/CompositedWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_COMPOSITED_WINDOW, PlankCompositedWindow);
#line 40 "../lib/Widgets/CompositedWindow.vala"
	gtk_widget_set_app_paintable ((GtkWidget*) self, TRUE);
#line 41 "../lib/Widgets/CompositedWindow.vala"
	gtk_window_set_decorated ((GtkWindow*) self, FALSE);
#line 42 "../lib/Widgets/CompositedWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 43 "../lib/Widgets/CompositedWindow.vala"
	gtk_widget_set_double_buffered ((GtkWidget*) self, FALSE);
#line 45 "../lib/Widgets/CompositedWindow.vala"
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
#line 45 "../lib/Widgets/CompositedWindow.vala"
	screen = _tmp0_;
#line 46 "../lib/Widgets/CompositedWindow.vala"
	_tmp2_ = screen;
#line 46 "../lib/Widgets/CompositedWindow.vala"
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
#line 46 "../lib/Widgets/CompositedWindow.vala"
	_tmp1_ = _tmp3_;
#line 46 "../lib/Widgets/CompositedWindow.vala"
	if (_tmp1_ == NULL) {
#line 149 "CompositedWindow.c"
		GdkScreen* _tmp4_;
		GdkVisual* _tmp5_;
#line 46 "../lib/Widgets/CompositedWindow.vala"
		_tmp4_ = screen;
#line 46 "../lib/Widgets/CompositedWindow.vala"
		_tmp5_ = gdk_screen_get_system_visual (_tmp4_);
#line 46 "../lib/Widgets/CompositedWindow.vala"
		_tmp1_ = _tmp5_;
#line 158 "CompositedWindow.c"
	}
#line 46 "../lib/Widgets/CompositedWindow.vala"
	gtk_widget_set_visual ((GtkWidget*) self, _tmp1_);
#line 38 "../lib/Widgets/CompositedWindow.vala"
	return obj;
#line 164 "CompositedWindow.c"
}

static void
plank_composited_window_class_init (PlankCompositedWindowClass * klass,
                                    gpointer klass_data)
{
#line 26 "../lib/Widgets/CompositedWindow.vala"
	plank_composited_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../lib/Widgets/CompositedWindow.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) plank_composited_window_real_draw;
#line 26 "../lib/Widgets/CompositedWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_composited_window_constructor;
#line 177 "CompositedWindow.c"
}

static void
plank_composited_window_instance_init (PlankCompositedWindow * self,
                                       gpointer klass)
{
}

/**
 * A {@link Gtk.Window} with compositing support enabled.
 * The default expose event will draw a completely transparent window.
 */
static GType
plank_composited_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankCompositedWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_composited_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankCompositedWindow), 0, (GInstanceInitFunc) plank_composited_window_instance_init, NULL };
	GType plank_composited_window_type_id;
	plank_composited_window_type_id = g_type_register_static (gtk_window_get_type (), "PlankCompositedWindow", &g_define_type_info, 0);
	return plank_composited_window_type_id;
}

GType
plank_composited_window_get_type (void)
{
	static volatile gsize plank_composited_window_type_id__once = 0;
	if (g_once_init_enter (&plank_composited_window_type_id__once)) {
		GType plank_composited_window_type_id;
		plank_composited_window_type_id = plank_composited_window_get_type_once ();
		g_once_init_leave (&plank_composited_window_type_id__once, plank_composited_window_type_id);
	}
	return plank_composited_window_type_id__once;
}

